<?php
function ReNew_config()
{
	$configarray = array(
		'name'        => '续费管理',
		'description' => '允许客户对已够产品进行续费操作。',
		'version'     => '1.7',
		'author'      => '<a href="http://neworld.org" target="_blank">NeWorld</a>',
		'fields'      => array()
		);


	$configarray['fields']['license'] = array('FriendlyName' => '优惠说明', 'Type' => 'na', 'Description' => '续费期限选择 1 年等于多少个月，默认 10 个月。（选择年付=续费金额x填写月份）');
	$configarray['fields']['years'] = array('FriendlyName' => '年度优惠', 'Type' => 'dropdown', 'Options' => '10,12', 'Default' => '12');


	return $configarray;
}

function ReNew_clientarea($vars)
{
		$productID = trim($_REQUEST['id']);
		$userID = trim($_SESSION['uid']);
		$invoiceID = trim($_SESSION['ReNewInvoice']);

		if (!empty($productID)) {
			$templatefile = 'renew';
		}
		else {
			$templatefile = 'index';
			$products = \Illuminate\Database\Capsule\Manager::table('tblhosting')->where('userid', $userID)->get();
			$product = array();

			foreach ($products as $key => $values) {
				$package = \Illuminate\Database\Capsule\Manager::table('tblproducts')->where('id', $values->packageid)->first();
				if (($values->billingcycle != 'Free Account') && ($values->billingcycle != 'One Time')) {
					if (($values->domainstatus == 'Active') || ($values->domainstatus == 'Suspended')) {
						$product[$key]['id'] = $values->id;
						$product[$key]['productname'] = $package->name;
						$product[$key]['domain'] = $values->domain;
						$product[$key]['regdate'] = $values->regdate;
						$product[$key]['nextduedate'] = $values->nextduedate;
						$product[$key]['amount'] = $values->amount;
					}
				}
			}
		}
/* [31m * TODO SEPARATE[0m */

		$products = \Illuminate\Database\Capsule\Manager::table('tblhosting')->where('userid', $userID)->where('domainstatus', 'Active')->where('id', $productID)->first();
		$package = \Illuminate\Database\Capsule\Manager::table('tblproducts')->where('id', $products->packageid)->first();
		$pricing = \Illuminate\Database\Capsule\Manager::table('tblpricing')->where('relid', $products->packageid)->where('currency', \Illuminate\Database\Capsule\Manager::table('tblclients')->where('id', $userID)->first()->currency)->first();
		$gateway = \Illuminate\Database\Capsule\Manager::table('tblpaymentgateways')->where('gateway', $products->paymentmethod)->where('setting', 'name')->first();

		switch ($products->billingcycle) {
		case 'Free Account':
			$results['billingcycle'] = LANG::trans('orderpaymenttermfreeaccount');
			break;

		case 'One Time':
			$results['billingcycle'] = LANG::trans('orderpaymenttermonetime');
			break;

		case 'Monthly':
			$results['billingcycle'] = LANG::trans('orderpaymenttermmonthly');
			$results['billingCycle'] = '<li data-time="1" data-date="1" class="active before">1</li><li data-time="2" data-date="2">2</li><li data-time="3" data-date="3">3</li><li data-time="4" data-date="4">4</li><li data-time="5" data-date="5">5</li><li data-time="6" data-date="6">6</li><li data-time="7" data-date="7">7</li><li data-time="8" data-date="8">8</li><li data-time="9" data-date="9">9</li><li data-time="12" data-date="12">1 年</li><li data-time="24" data-date="24">2 年</li><li data-time="36" data-date="36">3 年</li>';
			break;

		case 'Quarterly':
			$results['billingcycle'] = LANG::trans('orderpaymenttermquarterly');
			$results['billingCycle'] = '<li class="active before" data-time="3" data-date="1">3</li><li data-time="6" data-date="2">6</li><li data-time="9" data-date="3">9</li><li data-time="12" data-date="4">1 年</li><li data-time="24" data-date="8">2 年</li><li data-time="36" data-date="12">3 年</li>';
			break;

		case 'Semi-Annually':
			$results['billingcycle'] = LANG::trans('orderpaymenttermsemiannually');
			$results['billingCycle'] = '<li class="active before" data-time="6" data-date="1">6</li><li data-time="12" data-date="2">1 年</li><li data-time="24" data-date="4">2 年</li><li data-time="36" data-date="8">3 年</li>';
			break;

		case 'Annually':
			$results['billingcycle'] = LANG::trans('orderpaymenttermannually');
			$results['billingCycle'] = '<li class="active" data-time="12" data-date="1">1 年</li><li data-time="24" data-date="2">2 年</li><li data-time="36" data-date="3">3 年</li>';
			break;

		case 'Biennially':
			$results['billingcycle'] = LANG::trans('orderpaymenttermbiennially');
			$results['billingCycle'] = '<li class="active" data-time="24" data-date="1">2 年</li>';
			break;

		case 'Triennially':
			$results['billingcycle'] = LANG::trans('orderpaymenttermtriennially');
			$results['billingCycle'] = '<li class="active" data-time="36" data-date="1">3 年</li>';
			break;
		}

		$results['productname'] = $package->name;
		$results['productid'] = $package->id;
		$results['domain'] = $products->domain;
		$results['id'] = $products->id;
		$results['regdate'] = $products->regdate;
		$results['firstpaymentamount'] = $products->firstpaymentamount;
		$results['amount'] = $products->amount;
		$results['paytype'] = $package->paytype;
		$results['paymentmethod'] = $gateway->value;
		$results['payment'] = $products->paymentmethod;
		$results['nextduedate'] = $products->nextduedate;
		$FormatDate = strtotime($products->nextduedate);
		$time = trim($_GET['time']);
		$date = trim($_GET['date']);

		if ($vars['years'] == '10') {
			if ($date == '12') {
				$date = '10';
			}
			else if ($date == '24') {
				$date = '20';
			}
			else {
				if ($date == '36') {
					$date = '30';
				}
			}
		}

		if (!empty($date)) {
			$code = array('status' => 'success', 'date' => date('Y-m-d', strtotime('+' . $time . ' months', $FormatDate)), 'price' => bcmul($date, $results['amount'], 2));
			exit(json_encode($code));
		}

		if (!empty($_POST)) {
			$templatefile = 'confirm';
			$time = trim($_POST['timeCycle']);
			$num = trim($_POST['priceCycle']);

			if ($vars['years'] == '10') {
				if ($num == '12') {
					$num = '10';
				}
				else if ($num == '24') {
					$num = '20';
				}
				else {
					if ($num == '36') {
						$num = '30';
					}
				}
			}

			$billingcycle = bcmul($num, $results['amount'], 2);
			$endtime = date('Y-m-d', strtotime('+' . $time . ' months', $FormatDate));
			$admins = \Illuminate\Database\Capsule\Manager::table('tbladmins')->select('username')->first();
			$command = 'createinvoice';
			$adminuser = $admins->username;
			$values['userid'] = $userID;
			$values['date'] = date('Y-m-d', time());
			$values['duedate'] = '';
			$values['paymentmethod'] = $products->paymentmethod;
			$values['sendinvoice'] = true;
			$values['itemdescription1'] = $package->name . ' - ' . $products->domain . ' (' . $products->nextduedate . ' - ' . $endtime . ')';
			$values['itemamount1'] = $billingcycle;
			$values['itemtaxed1'] = 0;
			$results = localAPI($command, $values, $adminuser);

			if ($results['result'] == 'success') {
				$invoiceid = $results['invoiceid'];

				if ($invoiceid == '0') {
					$results['info'] = '<i class="alico icon-warning-2"></i> 您所选择的产品或服务目前无法续费。';
				}
				else {
					session_start();
					$_SESSION['ReNewInvoice'] = $invoiceid;
					header('refresh:3;url=' . $WEB_ROOT . 'viewinvoice.php?id=' . $invoiceid);
				}
			}
		}

		if (!empty($_GET['check'])) {
			if (!!trim($invoiceID)) {
				$invoice = \Illuminate\Database\Capsule\Manager::table('tblinvoices')->where('id', $invoiceID)->where('userid', $userID)->first();

				if (!empty($invoice)) {
					if ($invoice->status == 'Paid') {
						$endtime = \Illuminate\Database\Capsule\Manager::table('tblinvoiceitems')->where('invoiceid', $invoiceID)->where('userid', $userID)->first();
						preg_match_all('/(?:\\()(.*)(?:\\))/i', $endtime->description, $endtime);
						$endtime = $endtime[1][0];
						list(, $endtime) = explode(' - ', $endtime);
						$result = \Illuminate\Database\Capsule\Manager::table('tblhosting')->where('id', $_GET['check'])->where('userid', $userID)->update(array('nextduedate' => $endtime, 'nextinvoicedate' => $endtime));

						if (!empty($result)) {
							$code = array('status' => 'success');
							exit(json_encode($code));
						}

						unset($_SESSION['ReNewInvoice']);
					}
				}
			}
		}


	unset($_POST);
	return array(
	'pagetitle'    => '续费管理',
	'breadcrumb'   => array('index.php?m=ReNew' => '续费管理'),
	'templatefile' => 'templates/' . $templatefile,
	'requirelogin' => true,
	'vars'         => array('results' => $results, 'product' => $product, 'price' => empty($price) ? false : $price, 'id' => empty($productID) ? false : $productID, 'invoiceid' => empty($invoiceID) ? false : $invoiceID)
	);
}

if (!defined('WHMCS')) {
	exit('This file cannot be accessed directly');
}


?>
